<template>
  <div class="login-dialog">
    <v-card>
      <v-card-title
        class="headline primary"
        style="color: white"
        primary-title
      >Login bij Producerstore</v-card-title>
      <v-container>
        <v-form ref="form">
          <v-text-field
            prepend-icon="perm_identity"
            v-model="username"
            label="Gebruikersnaam"
            type="text"
            required
          ></v-text-field>
          <v-text-field
            prepend-icon="lock"
            v-model="password"
            label="Wachtwoord"
            type="password"
            required
          ></v-text-field>
        </v-form>
      </v-container>
      <v-divider></v-divider>

      <v-card-actions>
        <img
          @click="loginWithGoogle"
          class="google-button"
          src="@/assets/google-button.png"
          alt
          srcset
        >
        <v-spacer></v-spacer>
        <v-btn large color="secondary" @click="$emit('onClose')">Annuleer</v-btn>
        <v-btn large color="primary" @click="login" :loading="loading">Login</v-btn>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
export default {
  data() {
    return {
      username: null,
      password: null,
      loading: false
    };
  },

  methods: {
    async login() {
      this.loading = true;

      try {
        const user = await this.$authService.authenticate(
          this.username,
          this.password
        );

        this.$store.commit("setUser", user);

        this.$emit("onClose");
      } catch(e) {
        console.log(e)
        alert("Unauthorized :(");
      }

      this.loading = false;
    },

    async loginWithGoogle() {
      try {
        const googleUser = await this.$gAuth.signIn();
        const profile = googleUser.getBasicProfile();

        const user = await this.$authService.oAuth(googleUser.getAuthResponse().access_token);

        this.$store.commit("setUser", user);

        this.$emit("onClose");
      } catch {
        alert("Unauthorized :(");
      }
    }
  }
};
</script>

<style>
.google-button {
  /* display: none; */
  cursor: pointer;
}
</style>
